/*
 * CryptOutputStream.java
 */

package rpcs.io;

import java.io.OutputStream;
import java.io.IOException;


public class CryptOutputStream extends OutputStream {
    protected OutputStream out;
    protected String Cypher;
    protected byte[] bCypher;
    protected int CypherPos;
    protected int CypherLen;

    public CryptOutputStream(OutputStream out) {
	this.out = out;
	this.Cypher = new String("Z#$()aBc@-LkdGhq948GhdjWBddSEH");
	this.CypherLen = this.Cypher.length();
	this.bCypher = new byte[this.CypherLen];
	this.bCypher = this.Cypher.getBytes();
	this.CypherPos = -1;
    }

    public CryptOutputStream(OutputStream out, String cypher) {
	this.out = out;
	this.Cypher = new String(cypher);
	this.CypherLen = this.Cypher.length();
	this.bCypher = new byte[this.CypherLen];
	this.bCypher = this.Cypher.getBytes();
	this.CypherPos = -1;
    }

    public void write(int b) throws IOException {
	this.CypherPos++;
	if (CypherPos > CypherLen)
	   CypherPos = 0;
	out.write((int ) (bCypher[CypherPos] ^ b));
    }

    public void write(byte b[]) throws IOException {
	write(b, 0, b.length);
    }

    public void write(byte b[], int off, int len) throws IOException {
	for (int i = 0 ; i < len ; i++) {
	    write(b[off + i]);
	}
    }

    public void flush() throws IOException {
	out.flush();
    }

    public void close() throws IOException {
	try {
	  flush();
	} catch (IOException ignored) {
	}
	out.close();
    }
}
