
/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import java.awt.*;
import java.util.*;

import rpcs.system.*;

public class RPCSTableModel extends DefaultTableModel {
	Vector vEdit;
	String val;

	public RPCSTableModel() {
		super();
		vEdit = new Vector();
	}

	public RPCSTableModel(int x, int y) {
		super(x, y);
		vEdit = new Vector();
	}

	public boolean isCellEditable(int x, int y) {
		try {
		   val = (String )vEdit.elementAt(y);
		}
		catch (Exception e) { return true; }
		if (val.equals("1"))
			return true;
		else
			return false;
	}	

	public void setEditable(int x, boolean val) {
		vEdit.insertElementAt((val)?"1":"0", x);
	}
}
